pqxx::stateless_cursor< up, op > Class Template Reference

"Stateless cursor" class: easy API for retrieving parts of result sets More...

`#include <cursor.hxx>`

## Public Types

using | size_type = result_size_type
using | difference_type = result_difference_type

## Public Member Functions

| stateless_cursor (transaction_base &trans, const std::string &query, const std::string &cname, bool hold)
| Create cursor. More...
| stateless_cursor (transaction_base &trans, const std::string adopted_cursor)
| Adopt existing scrolling SQL cursor. More...
void | close () noexcept
size_type | size ()
| Number of rows in cursor's result set. More...
result | retrieve (difference_type begin_pos, difference_type end_pos)
| Retrieve rows from begin_pos (inclusive) to end_pos (exclusive) More...
const std::string & | name () const noexcept

## Detailed Description

### template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>
class pqxx::stateless_cursor< up, op >

"Stateless cursor" class: easy API for retrieving parts of result sets

This is a front-end for SQL cursors, but with a more C++-like API.

Actually, stateless_cursor feels entirely different from SQL cursors. You don't keep track of positions, fetches, and moves; you just say which rows you want. See the retrieve() member function.

## Member Typedef Documentation

## difference_type

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

using pqxx::stateless_cursor< up, op >::difference_type = result_difference_type

## size_type

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

using pqxx::stateless_cursor< up, op >::size_type = result_size_type

## Constructor & Destructor Documentation

## stateless_cursor() [1/2]

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

pqxx::stateless_cursor< up, op >::stateless_cursor | ( | transaction_base & | trans,
|  | const std::string & | query,
|  | const std::string & | cname,
|  | bool | hold
| ) |  |

Create cursor.

References pqxx::cursor_base::random_access.

## stateless_cursor() [2/2]

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

pqxx::stateless_cursor< up, op >::stateless_cursor | ( | transaction_base & | trans,
|  | const std::string | adopted_cursor
| ) |  |

Adopt existing scrolling SQL cursor.

## Member Function Documentation

## close()

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

void pqxx::stateless_cursor< up, op >::close | ( |  | ) |

noexcept

## name()

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

const std::string& pqxx::stateless_cursor< up, op >::name | ( |  | ) | const

noexcept

## retrieve()

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

result pqxx::stateless_cursor< up, op >::retrieve | ( | difference_type | begin_pos,
|  | difference_type | end_pos
| ) |  |

Retrieve rows from begin_pos (inclusive) to end_pos (exclusive)

Rows are numbered starting from 0 to size()-1.

Parameters

  begin_pos | First row to retrieve. May be one row beyond the end of the result set, to avoid errors for empty result sets. Otherwise, must be a valid row number in the result set.
  end_pos | Row up to which to fetch. Rows are returned ordered from begin_pos to end_pos, i.e. in ascending order if begin_pos < end_pos but in descending order if begin_pos > end_pos. The end_pos may be arbitrarily inside or outside the result set; only existing rows are included in the result.

References pqxx::stateless_cursor< up, op >::size().

## size()

template<cursor_base::updatepolicy up, cursor_base::ownershippolicy op>

size_type pqxx::stateless_cursor< up, op >::size | ( |  | ) |

Number of rows in cursor's result set.

Note
  This function is not const; it may need to scroll to find the size of the result set.

Referenced by pqxx::stateless_cursor< up, op >::retrieve().

The documentation for this class was generated from the following file:

- cursor.hxx